<template>
  <div>
    <v-card class="pl-6 pr-6 pb-5 pt-2">
      <v-card-title class="pb-0">
        <h1>
          <b v-if="proveedor">{{$t('editarProveedor')}}</b>
          <b v-else>{{$t('nuevoProveedor')}}</b>
        </h1>
      </v-card-title>
      <v-form v-model="valid" ref="proveedorFrom" class="pb-4 pt-4">
        <v-row>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-text-field
              v-model="form.nit"
              :rules="rules.isRequired"
              maxlength="10"
              :counter="10"
              onkeyup="value=value.replace(/[^0-9^\.]+/g,'').replace(/\./g,'').replace('$#$','.').replace(/^0+/, '')"
              dense
              :label="$t('nit')"
            />
          </v-col>
          <v-col cols="12" lg="8" md="8" sm="12">
            <v-text-field
              v-model="form.nombre"
              :rules="rules.isRequired"
              dense
              :label="$t('nombre')"
              @keyup="uppercase"
            />
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" lg="4" md="4" sm="12">
            <v-text-field
              v-model="form.telefono"
              :rules="rules.isRequired"
              maxlength="10"
              :counter="10"
              onkeyup="value=value.replace(/[^0-9^\.]+/g,'').replace(/\./g,'').replace('$#$','.').replace(/^0+/, '')"
              dense
              :label="$t('telefono')"
            />
          </v-col>
          <v-col cols="12" lg="8" md="8" sm="12">
            <v-text-field
              v-model="form.direccion"
              :rules="rules.isRequired"
              dense
              :label="$t('direccion')"
              @keyup="uppercase"
            />
          </v-col>
        </v-row>
      </v-form>
      <v-card-actions>
        <v-row>
          <v-btn
            color="accent"
            rounded
            @click="guardarProveedor"
          >
            {{$t('guardar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="cancelarGuardar">
            {{$t('cancelar')}}
          </v-btn>
          <br/>
        </v-row>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import ProveedorServicio from '@/store/services/ProveedorServicio'

export default {
  name:'ProveedoresForm',
  props: {
    proveedor: {
      type: Object,
      required: false,
      default: null
    }
  },
  data () {
    return {
      valid: false,
      form: {
        id: null,
        nit: '',
        nombre: '',
        telefono: '',
        direccion: '',
      },
      rules: {
        isRequired: [
          value => !!value || this.$t('campoRequerido'),
        ],
      },


      
      isLoading: false,
    }
  },
  methods: {
    async guardarProveedor() {
      try {
        if (this.$refs.proveedorFrom.validate()) {
          var response = ''
          if (!this.form.id || this.form.id === '') {
            let dataForm = new FormData()
            for (let key in this.form) {
              dataForm.append(key, this.form[key])
            }
            response = await ProveedorServicio.create(dataForm)
          } else {
            response = await ProveedorServicio.update(this.form.id, this.form)
          }
          this.resetData()
          this.$emit('onProveedorGuardado', response.data)
        }
      } catch (e) {
        console.log(e)
      }
    },
    cancelarGuardar() {
      this.resetData()
      this.$emit('onCancelarGuardar',  false);
    },
    setData() {
      if (this.proveedor) {
        this.form.id = this.proveedor.id
        this.form.nit = this.proveedor.nit
        this.form.nombre = this.proveedor.nombre
        this.form.telefono = this.proveedor.telefono
        this.form.direccion = this.proveedor.direccion
      }
    },

    uppercase() {
        this.form.nombre = this.form.nombre.toUpperCase();
        this.form.direccion = this.form.direccion.toUpperCase();
    },


    resetData() {
      this.$refs.proveedorFrom.reset()
      this.form.id = null
    }
  },
  computed: {

  },
  watch: {
    computedDateFormatted() {
      this.form.year = this.computedDateFormatted
    },
    proveedor: {
      immediate: true,
      handler() {
        this.setData()
      }
    }
  },
  created() {
    this.setData()
  }
}
</script>

<style>

</style>
